﻿// This file is part of Notepad++ project
// Copyright (C)2021 Don HO <don.h@free.fr>

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// at your option any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.
#pragma once

LocalizationSwitcher::LocalizationDefinition localizationDefs[] =
{
	{L"English",                L"english.xml"},
	{L"English (customizable)", L"english_customizable.xml"},
	{L"Français",               L"french.xml"},
	{L"台灣繁體",                L"taiwaneseMandarin.xml"},
	{L"中文简体",                L"chineseSimplified.xml"},
	{L"한국어",                  L"korean.xml"},
	{L"日本語",                  L"japanese.xml"},
	{L"Deutsch",                L"german.xml"},
	{L"Español",                L"spanish.xml"},
	{L"Italiano",               L"italian.xml"},
	{L"Português",              L"portuguese.xml"},
	{L"Português brasileiro",   L"brazilian_portuguese.xml"},
	{L"Nederlands",             L"dutch.xml"},
	{L"Русский",                L"russian.xml"},
	{L"Polski",                 L"polish.xml"},
	{L"Català",                 L"catalan.xml"},
	{L"Česky",                  L"czech.xml"},
	{L"Magyar",                 L"hungarian.xml"},
	{L"Română",                 L"romanian.xml"},
	{L"Türkçe",                 L"turkish.xml"},
	{L"فارسی",                  L"farsi.xml"},
	{L"Українська",             L"ukrainian.xml"},
	{L"עברית",                  L"hebrew.xml"},
	{L"Nynorsk",                L"nynorsk.xml"},
	{L"Norsk",                  L"norwegian.xml"},
	{L"Occitan",                L"occitan.xml"},
	{L"ไทย",                    L"thai.xml"},
	{L"Furlan",                 L"friulian.xml"},
	{L"العربية",                L"arabic.xml"},
	{L"Suomi",                  L"finnish.xml"},
	{L"Lietuvių",               L"lithuanian.xml"},
	{L"Ελληνικά",               L"greek.xml"},
	{L"Svenska",                L"swedish.xml"},
	{L"Galego",                 L"galician.xml"},
	{L"Slovenščina",            L"slovenian.xml"},
	{L"Slovenčina",             L"slovak.xml"},
	{L"Dansk",                  L"danish.xml"},
	{L"Estremeñu",              L"extremaduran.xml"},
	{L"Žemaitiu ruoda",         L"samogitian.xml"},
	{L"Български",              L"bulgarian.xml"},
	{L"Bahasa Indonesia",       L"indonesian.xml"},
	{L"Gjuha shqipe",           L"albanian.xml"},
	{L"Hrvatski",               L"croatian.xml"},
	{L"ქართული ენა",            L"georgian.xml"},
	{L"Euskara",                L"basque.xml"},
	{L"Español argentina",      L"spanish_ar.xml"},
	{L"Беларуская мова",        L"belarusian.xml"},
	{L"Srpski",                 L"serbian.xml"},
	{L"Cрпски",                 L"serbianCyrillic.xml"},
	{L"Bahasa Melayu",          L"malay.xml"},
	{L"Lëtzebuergesch",         L"luxembourgish.xml"},
	{L"Tagalog",                L"tagalog.xml"},
	{L"Afrikaans",              L"afrikaans.xml"},
	{L"Қазақша",                L"kazakh.xml"},
	{L"O‘zbekcha",              L"uzbek.xml"},
	{L"Ўзбекча",                L"uzbekCyrillic.xml"},
	{L"Кыргыз тили",            L"kyrgyz.xml"},
	{L"Македонски јазик",       L"macedonian.xml"},
	{L"latviešu valoda",        L"latvian.xml"},
	{L"தமிழ்",                  L"tamil.xml"},
	{L"Azərbaycan dili",        L"azerbaijani.xml"},
	{L"Bosanski",               L"bosnian.xml"},
	{L"Esperanto",              L"esperanto.xml"},
	{L"Zeneize",                L"ligurian.xml"},
	{L"हिन्दी",                    L"hindi.xml"},
	{L"Sardu",                  L"sardinian.xml"},
	{L"ئۇيغۇرچە",               L"uyghur.xml"},
	{L"తెలుగు",                  L"telugu.xml"},
	{L"aragonés",               L"aragonese.xml"},
	{L"বাংলা",                   L"bengali.xml"},
	{L"සිංහල",                  L"sinhala.xml"},
	{L"Taqbaylit",              L"kabyle.xml"},
	{L"मराठी",                   L"marathi.xml"},
	{L"tiếng Việt",             L"vietnamese.xml"},
	{L"Aranés",                 L"aranese.xml"},
	{L"ગુજરાતી",                 L"gujarati.xml"},
	{L"Монгол хэл",             L"mongolian.xml"},
	{L"اُردُو‎",              L"urdu.xml"},
	{L"ಕನ್ನಡ‎",             L"kannada.xml"},
	{L"Cymraeg",                L"welsh.xml"},
	{L"eesti keel",             L"estonian.xml"},
	{L"Тоҷик",                  L"tajikCyrillic.xml"},
	{L"татарча",                L"tatar.xml"},
	{L"ਪੰਜਾਬੀ",                   L"punjabi.xml"},
	{L"Corsu",                  L"corsican.xml"},
	{L"Brezhoneg",              L"breton.xml"},
	{L"کوردی‬",            L"kurdish.xml"},
	{L"Pig latin",              L"piglatin.xml"},
	{L"Zulu",                   L"zulu.xml"},
	{L"Vèneto",                 L"venetian.xml"},
	{L"Gaeilge",                L"irish.xml"},
	{L"नेपाली",                   L"nepali.xml"},
	{L"香港繁體",                L"hongKongCantonese.xml"},
	{L"Аԥсуа бызшәа",           L"abkhazian.xml"}
};
